- [HTTP request](https://docs.cloud.google.com/dataproc-metastore/docs/reference/rest/v1/projects.locations.services/restore#body.HTTP_TEMPLATE)
- [Path parameters](https://docs.cloud.google.com/dataproc-metastore/docs/reference/rest/v1/projects.locations.services/restore#body.PATH_PARAMETERS)
- [Request body](https://docs.cloud.google.com/dataproc-metastore/docs/reference/rest/v1/projects.locations.services/restore#body.request_body)
  - [JSON representation](https://docs.cloud.google.com/dataproc-metastore/docs/reference/rest/v1/projects.locations.services/restore#body.request_body.SCHEMA_REPRESENTATION)
- [Response body](https://docs.cloud.google.com/dataproc-metastore/docs/reference/rest/v1/projects.locations.services/restore#body.response_body)
- [Authorization scopes](https://docs.cloud.google.com/dataproc-metastore/docs/reference/rest/v1/projects.locations.services/restore#body.aspect)
- [Examples](https://docs.cloud.google.com/dataproc-metastore/docs/reference/rest/v1/projects.locations.services/restore#examples)
- [Try it!](https://docs.cloud.google.com/dataproc-metastore/docs/reference/rest/v1/projects.locations.services/restore#try-it)

Restores a service from a backup.

### HTTP request

`POST https://metastore.googleapis.com/v1/{service}:restore`

### Path parameters

| Parameters ||
|---|---|
| `service` | `string` Required. The relative resource name of the metastore service to run restore, in the following form: `projects/{projectId}/locations/{locationId}/services/{serviceId}`. Authorization requires the following [IAM](https://cloud.google.com/iam/docs/) permission on the specified resource `service`: - `metastore.services.restore` |

### Request body

The request body contains data with the following structure:

| JSON representation |
|---|
| ``` { "backup": string, "backupLocation": string, "restoreType": enum (`https://docs.cloud.google.com/dataproc-metastore/docs/reference/rest/v1/projects.locations.services#Service.RestoreType`), "requestId": string } ``` |

| Fields ||
|---|---|
| `backup` | `string` Optional. The relative resource name of the metastore service backup to restore from, in the following form: `projects/{projectId}/locations/{locationId}/services/{serviceId}/backups/{backupId}`. Mutually exclusive with `backupLocation`, and exactly one of the two must be set. Authorization requires the following [IAM](https://cloud.google.com/iam/docs/) permission on the specified resource `backup`: - `metastore.backups.use` |
| `backupLocation` | `string` Optional. A Cloud Storage URI specifying the location of the backup artifacts, namely - backup avro files under "avro/", backup_metastore.json and service.json, in the following form: `gs://<path_to_backup>`. Mutually exclusive with `backup`, and exactly one of the two must be set. |
| `restoreType` | ``enum (`https://docs.cloud.google.com/dataproc-metastore/docs/reference/rest/v1/projects.locations.services#Service.RestoreType`)`` Optional. The type of restore. If unspecified, defaults to `METADATA_ONLY`. |
| `requestId` | `string` Optional. A request ID. Specify a unique request ID to allow the server to ignore the request if it has completed. The server will ignore subsequent requests that provide a duplicate request ID for at least 60 minutes after the first request. For example, if an initial request times out, followed by another request with the same request ID, the server ignores the second request to prevent the creation of duplicate commitments. The request ID must be a valid [UUID](https://en.wikipedia.org/wiki/Universally_unique_identifier#Format). A zero UUID (00000000-0000-0000-0000-000000000000) is not supported. |

### Response body

If successful, the response body contains an instance of `https://docs.cloud.google.com/dataproc-metastore/docs/reference/rest/Shared.Types/ListOperationsResponse#Operation`.

### Authorization scopes

Requires the following OAuth scope:

- `https://www.googleapis.com/auth/cloud-platform`

For more information, see the [Authentication Overview](https://docs.cloud.google.com/docs/authentication#authorization-gcp).